<!--
Copyright 2020 The Chromium Authors. All rights reserved.
Use of this source code is governed by a BSD-style license that can be
found in the LICENSE file.
-->

<!--
This file is used to generate a comprehensive list of SBClient histograms
along with a detailed description for each histogram.

For best practices on writing histogram descriptions, see
https://chromium.googlesource.com/chromium/src.git/+/HEAD/tools/metrics/histograms/README.md

Please send CLs to chromium-metrics-reviews@google.com rather than to specific
individuals. These CLs will be automatically reassigned to a reviewer within
about 5 minutes. This approach helps the metrics team to load-balance incoming
reviews. Googlers can read more about this at go/gwsq-gerrit.
-->

<histogram-configuration>

<histograms>

<histogram name="SBClientDownload.CheckDownloadStats"
    enum="SBClientDownloadCheckDownloadStats" expires_after="2021-06-13">
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <owner>mattm@chromium.org</owner>
  <summary>
    Records a histogram of the reason why downloads are marked as being
    malicious or clean by the improved SafeBrowsing binary download protection.
    Note that UNSUPPORTED_URL_SCHEME was split out of the INVALID_URL bucket in
    M41. The NOT_BINARY_FILE check was moved before the UNSUPPORTED_URL_SCHEME
    check in M42. The WHITELISTED_URL check was moved to before NOT_BINARY_FILE
    in M62.
  </summary>
</histogram>

<histogram name="SBClientDownload.CheckWhitelistResult"
    enum="WhitelistedDownloadType" expires_after="M90">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    For each download supported by the SafeBrowsing download protection service,
    records if it matches a certain whitelist (e.g. matches URL whitelist,
    matches signature whitelist, or does not match any whitelists).
  </summary>
</histogram>

<histogram name="SBClientDownload.DeepScanTrigger" enum="SBDeepScanTriggers"
    expires_after="2021-04-28">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Records the reason each file was uploaded to Safe Browsing for deep
    scanning. This is logged on every deep scan.
  </summary>
</histogram>

<histogram name="SBClientDownload.DmgFileSuccessByType"
    enum="SBClientDownloadExtensions" expires_after="M90">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Counts of DMG-like file types that were successfully analyzed by the
    SafeBrowsing download service.
  </summary>
</histogram>

<histogram name="SBClientDownload.DownloadExtensions"
    enum="SBClientDownloadExtensions" expires_after="2021-06-27">
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <owner>mattm@chromium.org</owner>
  <summary>
    Records a histogram of how often users download a file with a file extension
    that is possibly dangerous (e.g., exe, class).
  </summary>
</histogram>

<histogram name="SBClientDownload.DownloadFileHasDmgSignature" enum="Boolean"
    expires_after="M81">
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    A Mac-only metric that records whether a given download file is a
    cryptographically signed DMG archive. This metric is logged before Chrome
    sends SafeBrowsing download pings.
  </summary>
</histogram>

<histogram name="SBClientDownload.DownloadRequestDuration" units="ms"
    expires_after="2021-08-23">
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <owner>mattm@chromium.org</owner>
  <summary>
    Records the total time it takes for the SafeBrowsing download service to
    check whether the content of a download is malicious or not, including file
    feature extraction, whitelist checking, and server ping. This histogram only
    includes checks that sent a ping to the SafeBrowsing server. It does not
    include requests that were cancelled, but does include requests that
    received a bad response.
  </summary>
</histogram>

<histogram name="SBClientDownload.DownloadRequestNetError" enum="NetErrorCodes"
    expires_after="2021-07-10">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <owner>mattm@chromium.org</owner>
  <summary>
    The net error code for all CheckClientDownloadRequest URLFetchers.
  </summary>
</histogram>

<histogram name="SBClientDownload.DownloadRequestNetworkDuration" units="ms"
    expires_after="2021-05-05">
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <owner>mattm@chromium.org</owner>
  <summary>
    Records the time it takes for the SafeBrowsing download service ping. It is
    not recorded for requests that were cancelled.
  </summary>
</histogram>

<histogram name="SBClientDownload.DownloadRequestNetworkStats"
    enum="SBClientDownloadCheckDownloadStats" expires_after="2021-05-05">
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <owner>mattm@chromium.org</owner>
  <summary>
    Records the results of SafeBrowsing binary download checks which caused a
    server ping.
  </summary>
</histogram>

<histogram name="SBClientDownload.DownloadRequestPayloadSize" units="bytes"
    expires_after="M90">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <owner>mattm@chromium.org</owner>
  <summary>
    The size of the upload data for CheckClientDownloadRequest URLFetchers.
  </summary>
</histogram>

<histogram name="SBClientDownload.DownloadRequestResponseCode"
    enum="HttpResponseCode" expires_after="2021-07-04">
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <owner>mattm@chromium.org</owner>
  <summary>
    For CheckClientDownloadRequest URLFetchers with successful status, the HTTP
    response code that was received.
  </summary>
</histogram>

<histogram name="SBClientDownload.ExtractDmgFeaturesTimeMedium" units="ms"
    expires_after="2021-07-21">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <owner>rsesek@chromium.org</owner>
  <summary>
    Records the time it takes for the SafeBrowsing download service to extract
    info from a downloaded DMG file.
  </summary>
</histogram>

<histogram name="SBClientDownload.ExtractRarFeaturesTimeMedium" units="ms"
    expires_after="2021-05-05">
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Records the time it takes for the SafeBrowsing download service to extract
    info from a downloaded rar file.
  </summary>
</histogram>

<histogram name="SBClientDownload.ExtractZipFeaturesTimeMedium" units="ms"
    expires_after="2021-05-05">
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <owner>mattm@chromium.org</owner>
  <summary>
    Records the time it takes for the SafeBrowsing download service to extract
    info from a downloaded zip file.
  </summary>
</histogram>

<histogram name="SBClientDownload.MalwareDeepScanResult.{trigger}"
    enum="SBClientDownloadCheckResult" expires_after="2021-04-28">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Records the result of a malware deep scan, split by the reason the file was
    uploaded for scanning. This is logged only for succesful scans. The overall
    rate of successful scans is logged in
    SafeBrowsingBinaryUploadRequest.MalwareResult.
  </summary>
  <token key="trigger">
    <variant name="AdvancedProtectionPrompt"
        summary="Advanced Protection user selected 'Scan'"/>
    <variant name="Policy" summary="Triggered by enterprise policy"/>
    <variant name="Unknown" summary="Unknown trigger"/>
  </token>
</histogram>

<histogram name="SBClientDownload.ZipFileSuccess" enum="BooleanSuccess"
    expires_after="M83">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    For each zip file analyzed by the SafeBrowsing download service, records if
    the unpacking was 100% successful.
  </summary>
</histogram>

<histogram name="SBClientMalware.IPBlacklistRequestNetError"
    enum="NetErrorCodes" expires_after="M85">
  <obsolete>
    Removed in 09-2020 since the SBClientMalware feature was removed.
  </obsolete>
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The net error code for all ClientMalwareRequest URLFetchers.
  </summary>
</histogram>

<histogram name="SBClientMalware.IPBlacklistRequestPayloadSize" units="bytes"
    expires_after="M85">
  <obsolete>
    Removed in 09-2020 since the SBClientMalware feature was removed.
  </obsolete>
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The size of the upload data for ClientMalwareRequest URLFetchers.
  </summary>
</histogram>

<histogram name="SBClientMalware.IPBlacklistRequestResponseCode"
    enum="HttpResponseCode" expires_after="M85">
  <obsolete>
    Removed in 09-2020 since the SBClientMalware feature was removed.
  </obsolete>
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    For ClientMalwareRequest URLFetchers with successful status, the HTTP
    response code that was received.
  </summary>
</histogram>

<histogram name="SBClientMalware.SentReports" enum="SBClientMalwareSentReports"
    expires_after="M85">
  <obsolete>
    Removed in 09-2020 since the SBClientMalware feature was removed.
  </obsolete>
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Measures the success rate of sending malware reports. Sending a report can
    fail due to a client reaching the limit on the number of reports it can send
    per day or due to the report failing to be serialized.
  </summary>
</histogram>

<histogram name="SBClientMalware.ServerDeterminesMalware"
    enum="BooleanIsMalware" expires_after="M85">
  <obsolete>
    Removed in 09-2020 since the SBClientMalware feature was removed.
  </obsolete>
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>The counts for malware verdicts given by server side model.</summary>
</histogram>

<histogram name="SBClientPhishing.CacheDetectsPhishing"
    enum="BooleanIsPhishing" expires_after="2021-09-17">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    When a result is served from cache, this histogram records whether the
    result was phishing or not.
  </summary>
</histogram>

<histogram name="SBClientPhishing.CancelClassificationReason"
    enum="SBClientPhishingCancelClassificationReason"
    expires_after="2021-06-13">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The counts for various reasons why an in-progress phishing classification
    was canceled.
  </summary>
</histogram>

<histogram name="SBClientPhishing.ClassificationStart" enum="BooleanHit"
    expires_after="2021-05-16">
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The number of pages that we could have possibly classified (essentially the
    number of top page navigations by users with SBClientPhishing enabled). The
    name is slightly misleading as it is recorded before
    &quot;Preclassification&quot; happens.
  </summary>
</histogram>

<histogram name="SBClientPhishing.Classifier.Event"
    enum="SBPhishingClassifierEvent" expires_after="2021-05-30">
  <owner>bdea@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Records events in the phishing classifier including reasons that prevents
    phishing detection to complete on the renderer side.
  </summary>
</histogram>

<histogram name="SBClientPhishing.ClassifierNotReadyReason"
    enum="SBClientPhishingClientModelStatus" expires_after="2021-06-27">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Records the result of the last model fetch. This is only recorded when
    classification fails because the model is not ready. This is useful for
    distinguishing different reasons the model may not be ready (never fetched,
    fetch failed, etc.)
  </summary>
</histogram>

<histogram name="SBClientPhishing.ClientModelDownloadResponseOrErrorCode"
    enum="CombinedHttpResponseAndNetErrorCode" expires_after="M90">
  <owner>drubery@google.com</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Response or error codes from the SafeBrowsing service. Logged after a
    request for the client side model finishes to capture the response code or
    the error code for that HTTP request.
  </summary>
</histogram>

<histogram name="SBClientPhishing.ClientModelStatus"
    enum="SBClientPhishingClientModelStatus" expires_after="2021-05-30">
  <owner>vakh@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The counts for various model status codes that we get after loading a new
    client-side phishing model.
  </summary>
</histogram>

<histogram name="SBClientPhishing.ClientModelVersionFetched" units="version"
    expires_after="2021-09-17">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Records the version of the local phishing detection model fetched. This
    histogram is logged each time we load a model.
  </summary>
</histogram>

<histogram name="SBClientPhishing.DOMFeatureChunkTime" units="ms"
    expires_after="M77">
  <owner>gab@chromium.org</owner>
  <summary>
    The time that an individual chunk of DOM feature extraction work took.
  </summary>
</histogram>

<histogram name="SBClientPhishing.DOMFeatureFrameRemoved" units="units"
    expires_after="M90">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@chromium.org</owner>
  <summary>
    The number of times that DOM feature extraction finished early because the
    active WebDocument's frame was removed during traversal.
  </summary>
</histogram>

<histogram name="SBClientPhishing.DOMFeatureIterations" units="units"
    expires_after="M77">
  <owner>gab@chromium.org</owner>
  <summary>
    The number of iterations that the DOM feature extractor took to finish.
  </summary>
</histogram>

<histogram name="SBClientPhishing.DOMFeatureResumeTime" units="ms"
    expires_after="2018-08-30">
  <owner>gab@chromium.org</owner>
  <summary>
    The time that it took to resume DOM feature extraction for the phishing
    classifier. Longer times may indicate that the page DOM changed between
    chunks of work and the extractor had to re-traverse up to the saved
    position.
  </summary>
</histogram>

<histogram name="SBClientPhishing.DOMFeatureTimeout" units="units"
    expires_after="M90">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The number of phishing classifications that were aborted because DOM feature
    extraction took too long.
  </summary>
</histogram>

<histogram name="SBClientPhishing.DOMFeatureTotalTime" units="ms"
    expires_after="M77">
  <owner>gab@chromium.org</owner>
  <summary>
    The time that the DOM feature extarctor took to finish, summed across all
    chunks of work.
  </summary>
</histogram>

<histogram name="SBClientPhishing.IllegalFeatureValue" units="units"
    expires_after="M90">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The number of features which were omitted from phishing classification
    because they were added with an illegal value. This would indicate a bug.
  </summary>
</histogram>

<histogram name="SBClientPhishing.LocalModelDetectsPhishing"
    enum="BooleanIsPhishing" expires_after="2021-09-17">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Records whether the local phishing detection model detects phishing. This
    histogram is logged each time the model is run (roughly on every navigation
    to a non-allowlisted site)
  </summary>
</histogram>

<histogram name="SBClientPhishing.PageCapturedMatchesBrowserURL"
    enum="BooleanMatched" expires_after="2021-01-27">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    This records whether a page capture event matches the last URL requested
    from the browser process. This histogram is recorded on every page capture
    event.
  </summary>
</histogram>

<histogram name="SBClientPhishing.PhishingDetectionDuration" units="ms"
    expires_after="2021-06-13">
  <owner>bdea@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Records the duration it takes for client side phishing detection to finish.
  </summary>
</histogram>

<histogram name="SBClientPhishing.PhishingDetectorResult"
    enum="ClientSidePhishingResult" expires_after="2021-06-06">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>The result enum received from the renderer-side classifier</summary>
</histogram>

<histogram name="SBClientPhishing.PreClassificationCheckResult"
    enum="SBClientDetectionPreClassificationCheckResult"
    expires_after="2021-05-16">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Records the result of phishing pre-classification checks. This is recorded
    on every classification attempt (roughly every page load).
  </summary>
</histogram>

<histogram name="SBClientPhishing.ReportLimitSkipped" enum="BooleanHit"
    expires_after="2021-01-27">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The number of phishing classifications that were previously cached as being
    phishing but that will get re-classified (to possibly fix false positives).
  </summary>
</histogram>

<histogram name="SBClientPhishing.RequestNotSerialized" units="units"
    expires_after="M90">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The number of phishing classifier pingbacks that were skipped because
    serializing the request protocol buffer to string failed.
  </summary>
</histogram>

<histogram name="SBClientPhishing.RequestSatisfiedFromCache" enum="BooleanHit"
    expires_after="M90">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The number of times that a cached phishing classification result was used,
    rather than pinging the server.
  </summary>
</histogram>

<histogram name="SBClientPhishing.ScorerCreationStatus"
    enum="SBClientPhishingScorerCreationStatus" expires_after="M90">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Records the status when we create a scorer object for the client-side
    phishing detection classifier.
  </summary>
</histogram>

<histogram name="SBClientPhishing.ServerModelDetectsPhishing"
    enum="BooleanIsPhishing" expires_after="2021-09-17">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Records whether the server-side phishing detection model detects phishing.
    This histogram is logged each time we contact Safe Browsing to evaluate
    whether a site is phishing.
  </summary>
</histogram>

<histogram name="SBClientPhishing.TermFeatureBreakIterError" units="units"
    expires_after="M90">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The number of phishing classifications that were aborted because the term
    feature extractor failed to initialize an ICU break iterator.
  </summary>
</histogram>

<histogram name="SBClientPhishing.TermFeatureChunkTime" units="ms"
    expires_after="2021-06-13">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The time that an individual chunk of term feature extraction work took.
  </summary>
</histogram>

<histogram name="SBClientPhishing.TermFeatureIterations" units="units"
    expires_after="2021-06-27">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The number of iterations that the term feature extractor took to finish.
  </summary>
</histogram>

<histogram name="SBClientPhishing.TermFeatureTimeout" units="units"
    expires_after="2021-06-13">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The number of phishing classification that were aborted because term feature
    extraction took too long.
  </summary>
</histogram>

<histogram name="SBClientPhishing.TermFeatureTotalTime" units="ms"
    expires_after="2021-06-20">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The time that the term feature extarctor took to finish, summed across all
    chunks of work.
  </summary>
</histogram>

<histogram name="SBClientPhishing.TooManyFeatures" units="units"
    expires_after="2021-01-27">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The number of times that the limit on the number of phishing classifier
    features for a page was reached. This may indicate a bug, or that
    kMaxFeatureSize is too small.
  </summary>
</histogram>

<histogram name="SBClientPhishing.URLFeatureTime" units="ms"
    expires_after="2021-01-27">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    The time taken to extract URL features for the phishing classifier.
  </summary>
</histogram>

<histogram name="SBClientPhishing.VisualComparisonTime" units="ms"
    expires_after="2021-05-22">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Records how long it took to compare visual features against the visual
    phishing model. This is recorded on every phishing classification.
  </summary>
</histogram>

<histogram name="SBClientPhishing.VisualFeatureTime" units="ms"
    expires_after="2021-06-06">
  <owner>drubery@chromium.org</owner>
  <owner>chrome-safebrowsing-alerts@google.com</owner>
  <summary>
    Records how long it took to extract visual features. This is recorded on
    every phishing classification.
  </summary>
</histogram>

</histograms>

</histogram-configuration>
